#include <math.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <windows.h>

#define PI  3.1415926535897932384626433832795
#define E	2.7182818284590452353602874713527
#define TEN9  1000000000
typedef unsigned __int64 UINT64;
typedef unsigned long DWORD;


//x / 1000000000 ̣ *pRemaindercʵ
inline DWORD Div_TEN9_1(UINT64 x,DWORD *pRemainder )
{

	*pRemainder=(DWORD)( x % (UINT64)TEN9);
	return DWORD (x / (UINT64)TEN9);
}

//x / 1000000000 ̣ *pRemainderǶʽʵ
inline DWORD Div_TEN9_2(UINT64 x,DWORD *pRemainder )
{
	_asm
	{
		lea ebx,x
		mov eax,[ebx]   // low DWORD 
		mov edx,[ebx+4] // high DWORD 
		//------------------
		mov ebx,TEN9
		div ebx
		//-----------------
		mov ebx,pRemainder
		mov [ebx],edx		// remainder-> *remainder
	}
}

int calcResultLen(DWORD n)
{
	return log10(2*PI*(double)n)/2 + n *  log10((double)n/E)+1;
}

double currTime(LARGE_INTEGER *freq) //ʹø߾ȼʱ
{
	LARGE_INTEGER performanceCount;
	BOOL result=QueryPerformanceCounter(  &performanceCount );
	double time= performanceCount.HighPart * 4294967296.0 + performanceCount.LowPart;
	time=time / (   freq->HighPart * 4294967296.0 + freq->LowPart);
	return time;
}

void printfResult(DWORD *buff,int buffLen,char *fileName)
{
	DWORD *p=buff;
	FILE *fp=NULL;
	//-----------------------------
	while ( *p==0)	p++;
	if (fileName==NULL)		return ;
	fp=fopen(fileName,"wt");
	if (fp==NULL)
	{
		printf("can't create file %s",fileName);
		return ;
	}

	for ( int i=0;i<buffLen;i++)
	{
		if (i==0)
			fprintf(fp,"%9d ",p[i]);
		else
			fprintf(fp,"%09d ",p[i]);
		
		if (i % 8==7)
			fprintf(fp,"\n");			
	}
	fprintf(fp,"\n");
	fclose(fp);
}

void calcFac(DWORD *buff, int buffLen,DWORD n)
{
	int	  len=1;
	DWORD carry,*p,*pEnd,*pBeg;
	unsigned __int64 prod;
	//------------------------
	memset(buff,0, sizeof(DWORD)*buffLen);
	pBeg=buff+buffLen-1;
	*pBeg=1;
	for (DWORD i=2;i<=n;i++)
	{
		for (p=pBeg,pEnd=p-len,carry=0;p>pEnd;p--)
		{
			prod= (UINT64)(*p) * (UINT64)i + (UINT64)carry;
			carry=Div_TEN9_1(prod,p );
			//carry=Div_TEN9_2(prod,p );
		}
		if (carry>0)
		{
			*(pBeg-len)=carry;
			len++;
		}
	}
}

int main(int argc, char* argv[])
{
	DWORD n=1;
	char fileName[16];
	double start,end;
	LARGE_INTEGER freq;
	if ( !QueryPerformanceFrequency( &freq) )
	{
		printf("ʹø߾ȼʱ");
		return 0;
	}
	
	printf("n=?");
	scanf("%d",&n);
	int buffLen=(calcResultLen(n)+8) / 9;
	DWORD *buff=new DWORD[buffLen];
	//---------------------
	start=currTime(&freq);
	calcFac(buff, buffLen, n);
	end=currTime(&freq);
	printf("̺ʱ%.6f\n",end-start);
	//-----------------------------
	start=currTime(&freq);
	sprintf(fileName,"%d!.txt",n);
	printfResult(buff,buffLen,fileName); //output to file
	end=currTime(&freq);
	//-----------------------------------
	printf("̺ʱ%.6f\n",end-start);

	delete[] buff;
	getche(); //pause
	return 0;
}

